#lang racket

; Attempt 1
#|
(define (sum numbers)
  (match numbers
    [(list) (display "empty list")]
    ;[(list 10 t ...) (displayln "special list!")]
    [(list h t ...) (displayln (format "first: ~a    rest: ~a" h t) )]
  )
)

;(sum (list 1 2 3))
; (sum (list 1))
 (sum (list 10 2 3))

 |#
; numbers = (list 1 2 3)
(define (sum numbers)
  (match numbers
    [(list) 0]
    [(list h numbers ...)
      ; h = 1
      ; numbers = (2 3)
      ; result = (sum (list 2 3)) = 5
      (define result (sum numbers))
      (+ h result) ; 6
    ]
  )
)

; (sum (list 1 2 3 4))
; n = 3
; (list 3 2 1)
(define (count-down n)
  (cond
    [(<= n 0)  (list)]
    [else
      ; result = (count-down 2) = (list 2 1)
      (define result (count-down (- n 1)))
      ; expected output: (list 3 2 1)
      (cons n result)
    ]
  )
)

#|
(define (count-down n)
  (match n
    [0   (list)]
    [n #:when (>= n 0)
)
|#

; l1 = (list 3 2 1)
; l2 = (list 30 20 10)
(define (zip l1 l2)
  (match* (l1 l2)
    [((list h1 l1 ...)  (list h2 l2 ...))
      ; h1 = 3
      ; l1 = (list 2 1)
      ; h2 = 30
      ; l2 = (list 20 10)
      ; result = (list (2 . 20) (1 . 10))
      (define result (zip l1 l2)) ;
      (define h (cons h1 h2)) ; h = (3 . 30)
      (cons h result)
      ; output
      ; (list (3 . 30) (2 . 20) (1 . 10))
      ;       --------  ~~~~~~~~~~~~~~~~~
      ;          h           result
    ]
    [(_ _)  (list)]
  )
)

; (zip (list 3 2 1) (list 30 20 10))

; (countup-from1 3) -> (list 1 2 3)
; (countup-from1 2) -> (list 1 2)
; (countup-from1 1) -> (list 1)

; (countup-from 1 3) -> (list 1 2 3)
; (countup-from 2 3) -> (list 2 3)
; (countup-from 3 3) -> (list 3)
; (countup-from 4 3) -> (list)

; lb = 1
; ub = 3
; output = (list 1 2 3)
(define (countup-from lb ub)
  (cond
    [(> lb ub) (list)]
    [else
      (define result (countup-from (+ lb 1) ub))
      ; result = (list 2 3)
      ; lb = 1
      ; ub = 3
      (cons lb result)
    ]
  )
)
; (countup-from 3 3)

; (countup-from 10 1000)

(define (countup-from1 n)
  (countup-from 1 n)
)



(define (countup-from1-v2 n)
  (define (countup-from-v2 lb)
    (cond
      [(> lb n) (list)]
      [else
        (define result (countup-from-v2 (+ lb 1)))
        ; result = (list 2 3)
        ; lb = 1
        ; ub = 3
        (cons lb result)
      ]
    )
  )
  (countup-from-v2 1)
)


;(countup-from1-v2 1000)

#|
(define z 10)
(define (f)
  (define x 3) ; Shadows parameter
  ;(define z 20)  ; Shadows global
  z)
(f) ; Outputs 23|#


(define (max xs)
  (cond
    [(empty? xs) (error "max: expecting a non-empty list!")]
    [(equal? (length xs) 1) (first xs)]             ; The list only has one element (the max)
    [else
      (define result (max (rest xs)))
      (cond [(> (first xs) result) (first xs)] ; The max of the rest is smaller than 1st
            [else result])
    ]
  )
)
; A simple unit-test

(max (list 1 2 10 4 0))











